/*
 * QTMenu.cpp
 *
 *  Created on: Jan 15, 2010
 *      Author: crueger
 */

#include "Menu/QT4/QTMenu.hpp"

#include <Qt/qaction.h>
#include "Menu/MenuItem.hpp"

QTMenu::QTMenu(const char * _title) :
  QMenu(_title)
{
  // TODO Auto-generated constructor stub

}

QTMenu::~QTMenu()
{
  // TODO Auto-generated destructor stub
}

void QTMenu::addItem(MenuItem* item) {
  const string description = item->getDescription();
  QAction *action = addAction(QString(description.c_str()));
  QTPipe *pipe = new QTPipe(item,action);
  QObject::connect(action, SIGNAL(triggered()),pipe,SLOT(called()));
  plumbing.push_back(pipe);
}

void QTMenu::removeItem(MenuItem* item) {
  list<QTPipe*>::iterator iter;
  for(iter=plumbing.begin(); iter!=plumbing.end(); iter++){
    delete (*iter);
  }
}

void QTMenu::display() {

}

QTPipe::QTPipe(MenuItem *_item, QAction *_action) :
    theItem(_item), theAction(_action)
{}

QTPipe::~QTPipe() {
  delete theAction;
  delete theItem;
}

void QTPipe::called() {
  theItem->doTrigger();
}
